/// @cond EO_CXX_EO_IMPL

inline void elm::thumb::reload() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_reload());
}

inline void elm::thumb::compress_get(int* compress_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_compress_get(compress_));
}

inline void elm::thumb::compress_set(int compress_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_compress_set(compress_));
}

inline Ethumb_Thumb_Format elm::thumb::format_get() const
{
   Ethumb_Thumb_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_format_get());
   return _tmp_ret;
}

inline void elm::thumb::format_set(Ethumb_Thumb_Format format_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_format_set(format_));
}

inline Elm_Thumb_Animation_Setting elm::thumb::animate_get() const
{
   Elm_Thumb_Animation_Setting _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_animate_get());
   return _tmp_ret;
}

inline void elm::thumb::animate_set(Elm_Thumb_Animation_Setting setting_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_animate_set(setting_));
}

inline Ethumb_Thumb_FDO_Size elm::thumb::fdo_size_get() const
{
   Ethumb_Thumb_FDO_Size _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_fdo_size_get());
   return _tmp_ret;
}

inline void elm::thumb::fdo_size_set(Ethumb_Thumb_FDO_Size size_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_fdo_size_set(size_));
}

inline Ethumb_Thumb_Orientation elm::thumb::orientation_get() const
{
   Ethumb_Thumb_Orientation _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_orientation_get());
   return _tmp_ret;
}

inline void elm::thumb::orientation_set(Ethumb_Thumb_Orientation orient_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_orientation_set(orient_));
}

inline bool elm::thumb::editable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::thumb::editable_set(bool edit_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_set(::efl::eolian::to_c(edit_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Ethumb_Thumb_Aspect elm::thumb::aspect_get() const
{
   Ethumb_Thumb_Aspect _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_aspect_get());
   return _tmp_ret;
}

inline void elm::thumb::aspect_set(Ethumb_Thumb_Aspect aspect_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_aspect_set(aspect_));
}

inline void elm::thumb::quality_get(int* quality_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_quality_get(quality_));
}

inline void elm::thumb::quality_set(int quality_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_quality_set(quality_));
}

inline void elm::thumb::size_get(int* tw_, int* th_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_size_get(tw_, th_));
}

inline void elm::thumb::size_set(int tw_, int th_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_size_set(tw_, th_));
}

inline void elm::thumb::crop_align_get(double* cropx_, double* cropy_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_crop_align_get(cropx_, cropy_));
}

inline void elm::thumb::crop_align_set(double cropx_, double cropy_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_crop_align_set(cropx_, cropy_));
}

inline void elm::thumb::path_get(const char ** file_, const char ** key_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_path_get(file_, key_));
}

inline void eo_cxx::elm::thumb::reload() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_reload());
}

inline void eo_cxx::elm::thumb::compress_get(int* compress_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_compress_get(compress_));
}

inline void eo_cxx::elm::thumb::compress_set(int compress_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_compress_set(compress_));
}

inline Ethumb_Thumb_Format eo_cxx::elm::thumb::format_get() const
{
   Ethumb_Thumb_Format _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_format_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::thumb::format_set(Ethumb_Thumb_Format format_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_format_set(format_));
}

inline Elm_Thumb_Animation_Setting eo_cxx::elm::thumb::animate_get() const
{
   Elm_Thumb_Animation_Setting _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_animate_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::thumb::animate_set(Elm_Thumb_Animation_Setting setting_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_animate_set(setting_));
}

inline Ethumb_Thumb_FDO_Size eo_cxx::elm::thumb::fdo_size_get() const
{
   Ethumb_Thumb_FDO_Size _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_fdo_size_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::thumb::fdo_size_set(Ethumb_Thumb_FDO_Size size_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_fdo_size_set(size_));
}

inline Ethumb_Thumb_Orientation eo_cxx::elm::thumb::orientation_get() const
{
   Ethumb_Thumb_Orientation _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_orientation_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::thumb::orientation_set(Ethumb_Thumb_Orientation orient_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_orientation_set(orient_));
}

inline bool eo_cxx::elm::thumb::editable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::thumb::editable_set(bool edit_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_set(::efl::eolian::to_c(edit_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Ethumb_Thumb_Aspect eo_cxx::elm::thumb::aspect_get() const
{
   Ethumb_Thumb_Aspect _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_thumb_aspect_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::thumb::aspect_set(Ethumb_Thumb_Aspect aspect_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_aspect_set(aspect_));
}

inline void eo_cxx::elm::thumb::quality_get(int* quality_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_quality_get(quality_));
}

inline void eo_cxx::elm::thumb::quality_set(int quality_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_quality_set(quality_));
}

inline void eo_cxx::elm::thumb::size_get(int* tw_, int* th_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_size_get(tw_, th_));
}

inline void eo_cxx::elm::thumb::size_set(int tw_, int th_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_size_set(tw_, th_));
}

inline void eo_cxx::elm::thumb::crop_align_get(double* cropx_, double* cropy_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_crop_align_get(cropx_, cropy_));
}

inline void eo_cxx::elm::thumb::crop_align_set(double cropx_, double cropy_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_crop_align_set(cropx_, cropy_));
}

inline void eo_cxx::elm::thumb::path_get(const char ** file_, const char ** key_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_thumb_path_get(file_, key_));
}

inline ::eo_cxx::elm::thumb::operator ::elm::thumb() const
{
   return *static_cast<::elm::thumb const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::thumb::operator ::elm::thumb&()
{
   return *static_cast<::elm::thumb*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::thumb::operator ::elm::thumb const&() const
{
   return *static_cast<::elm::thumb const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_thumb_reload_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->reload();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_compress_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* compress_)
{
   try
      {
         static_cast<T*>(self->this_)->compress_get(compress_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_compress_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int compress_)
{
   try
      {
         static_cast<T*>(self->this_)->compress_set(compress_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Ethumb_Thumb_Format elm_thumb_format_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->format_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Ethumb_Thumb_Format _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_thumb_format_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_Format format_)
{
   try
      {
         static_cast<T*>(self->this_)->format_set(format_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Thumb_Animation_Setting elm_thumb_animate_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->animate_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Thumb_Animation_Setting _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_thumb_animate_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Thumb_Animation_Setting setting_)
{
   try
      {
         static_cast<T*>(self->this_)->animate_set(setting_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Ethumb_Thumb_FDO_Size elm_thumb_fdo_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->fdo_size_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Ethumb_Thumb_FDO_Size _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_thumb_fdo_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_FDO_Size size_)
{
   try
      {
         static_cast<T*>(self->this_)->fdo_size_set(size_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Ethumb_Thumb_Orientation elm_thumb_orientation_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->orientation_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Ethumb_Thumb_Orientation _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_thumb_orientation_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_Orientation orient_)
{
   try
      {
         static_cast<T*>(self->this_)->orientation_set(orient_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_thumb_editable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->editable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_thumb_editable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool edit_)
{
   try
      {
         return static_cast<T*>(self->this_)->editable_set(::efl::eolian::to_cxx<bool>(edit_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
Ethumb_Thumb_Aspect elm_thumb_aspect_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->aspect_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Ethumb_Thumb_Aspect _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_thumb_aspect_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_Aspect aspect_)
{
   try
      {
         static_cast<T*>(self->this_)->aspect_set(aspect_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_quality_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* quality_)
{
   try
      {
         static_cast<T*>(self->this_)->quality_get(quality_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_quality_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int quality_)
{
   try
      {
         static_cast<T*>(self->this_)->quality_set(quality_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int* tw_, int* th_)
{
   try
      {
         static_cast<T*>(self->this_)->size_get(tw_, th_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int tw_, int th_)
{
   try
      {
         static_cast<T*>(self->this_)->size_set(tw_, th_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_crop_align_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* cropx_, double* cropy_)
{
   try
      {
         static_cast<T*>(self->this_)->crop_align_get(cropx_, cropy_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_crop_align_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double cropx_, double cropy_)
{
   try
      {
         static_cast<T*>(self->this_)->crop_align_set(cropx_, cropy_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_thumb_path_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char ** file_, const char ** key_)
{
   try
      {
         static_cast<T*>(self->this_)->path_get(file_, key_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::thumb >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::efl::file >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
   {
      virtual void reload()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_reload());
      }

      virtual void compress_get(int* compress_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_compress_get(compress_));
      }

      virtual void compress_set(int compress_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_compress_set(compress_));
      }

      virtual Ethumb_Thumb_Format format_get()
      {
         Ethumb_Thumb_Format _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_format_get());
            return _tmp_ret;
      }

      virtual void format_set(Ethumb_Thumb_Format format_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_format_set(format_));
      }

      virtual Elm_Thumb_Animation_Setting animate_get()
      {
         Elm_Thumb_Animation_Setting _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_animate_get());
            return _tmp_ret;
      }

      virtual void animate_set(Elm_Thumb_Animation_Setting setting_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_animate_set(setting_));
      }

      virtual Ethumb_Thumb_FDO_Size fdo_size_get()
      {
         Ethumb_Thumb_FDO_Size _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_fdo_size_get());
            return _tmp_ret;
      }

      virtual void fdo_size_set(Ethumb_Thumb_FDO_Size size_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_fdo_size_set(size_));
      }

      virtual Ethumb_Thumb_Orientation orientation_get()
      {
         Ethumb_Thumb_Orientation _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_orientation_get());
            return _tmp_ret;
      }

      virtual void orientation_set(Ethumb_Thumb_Orientation orient_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_orientation_set(orient_));
      }

      virtual bool editable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_editable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool editable_set(bool edit_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_editable_set(::efl::eolian::to_c(edit_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Ethumb_Thumb_Aspect aspect_get()
      {
         Ethumb_Thumb_Aspect _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_aspect_get());
            return _tmp_ret;
      }

      virtual void aspect_set(Ethumb_Thumb_Aspect aspect_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_aspect_set(aspect_));
      }

      virtual void quality_get(int* quality_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_quality_get(quality_));
      }

      virtual void quality_set(int quality_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_quality_set(quality_));
      }

      virtual void size_get(int* tw_, int* th_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_size_get(tw_, th_));
      }

      virtual void size_set(int tw_, int th_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_size_set(tw_, th_));
      }

      virtual void crop_align_get(double* cropx_, double* cropy_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_crop_align_get(cropx_, cropy_));
      }

      virtual void crop_align_set(double cropx_, double cropy_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_crop_align_set(cropx_, cropy_));
      }

      virtual void path_get(const char ** file_, const char ** key_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_path_get(file_, key_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::thumb >
{
   static constexpr int value = 
#if defined(THUMB_PROTECTED) && defined(THUMB_BETA)
      22
#elif defined(THUMB_PROTECTED)
      22
#elif defined(THUMB_BETA)
      22
#else
      22
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::efl::file >::value      + operation_description_class_size<::evas::clickable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::thumb>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_reload_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_reload);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_compress_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_compress_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_compress_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_compress_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_format_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_format_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_format_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_format_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_animate_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_animate_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_animate_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_animate_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_fdo_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_fdo_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_fdo_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_fdo_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_orientation_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_orientation_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_orientation_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_orientation_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_editable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_editable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_editable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_editable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_aspect_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_aspect_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_aspect_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_aspect_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_quality_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_quality_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_quality_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_quality_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_crop_align_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_crop_align_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_crop_align_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_crop_align_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_thumb_path_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_path_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::thumb >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::file>(), &ops[operation_description_class_size< ::elm::thumb >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::thumb >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::efl::file>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::thumb>)
{
   return (ELM_THUMB_CLASS);
}

} } }

/// @endcond

